;Grafikeinstellungen
Local gWidth = 640, gHeight = 480, gDepth = 0, gWindowed = 1
Local VRAM = 0

;Titel
AppTitle "Flucht"

;Auflsung und Fenster
Graphics3D gWidth, gHeight, gDepth, gWindowed*2
SetBuffer BackBuffer()

;Zufall
SeedRnd MilliSecs()

;Variablen definieren und gegebenfalls mit Werten belegen
Include "initialize.bb"



;-----------------------------------------------------------------------------------------------------------------------------------------------
;--------------------------------------------------------------- Das Intro ---------------------------------------------------------------------
;-----------------------------------------------------------------------------------------------------------------------------------------------

;Alles ntige laden
Include "buildHouse.bb"

;Licht
AmbientLight 255, 200, 0

;Protagonistin positionieren
Gosub setPlayerStandard
PositionEntity playerPiv1, -6, 4.01, -10
RotateEntity playerPiv1, 0, -90, 0
RotateEntity playerCam, 25, 0, 0
Gosub setPlayerCollision

;Welt-Kollision
EntityType houseMesh, 2
Collisions 1, 2, 2, 2

;Dialog
Local dialogue = PlayMusic("sound\dialogue.ogg")

;Fading
EntityColor fadeSprite, 0, 0, 0
EntityAlpha fadeSprite, 1
fadeAlpha = 1

;Hauptschleife
Repeat
	If playerTimer < MilliSecs() Then
		Gosub movePlayer
		
		fadeAlpha = fadeAlpha - 0.1
		If fadeAlpha < 0 Then fadeAlpha = 0
		EntityAlpha fadeSprite, fadeAlpha
		
		playerTimer = MilliSecs()+20
	EndIf
	
	UpdateWorld
	RenderWorld
			
	Flip
	
	If ChannelPlaying(dialogue) = 0 Then Exit
Until KeyHit(1)

;Alles lschen
FreeEntity houseMesh
FreeTexture houseTex
FreeEntity laurenMesh
FreeTexture laurenTex
FreeEntity jillMesh
FreeTexture jillTex
FreeEntity boardSprite
FreeTexture boardTex
StopChannel dialogue

;-----------------------------------------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------- Der Labyrinth-Level ----------------------------------------------------------------
;-----------------------------------------------------------------------------------------------------------------------------------------------

;Labyrinth erstellen
Include "createMaze.bb"
pathState = 1.0

;Licht
AmbientLight 255, 100, 100

;Protagonistin positionieren
Gosub setPlayerStandard
PositionEntity playerPiv1, (startX*18)+3, 4.01, (startY*18)+3
If maze(startX, startY-1) = 2 Then RotateEntity playerPiv1, 0, 180, 0
If maze(startX-1, startY) = 2 Then RotateEntity playerPiv1, 0, +90, 0
If maze(startX, startY+1) = 2 Then RotateEntity playerPiv1, 0, 0, 0
If maze(startX+1, startY) = 2 Then RotateEntity playerPiv1, 0, -90, 0
Gosub setPlayerCollision

;Labyrinth-Kollision
EntityType mazeMesh, 2
Collisions 1, 2, 2, 2

;Tren einbauen
Gosub buildDoors

;Sichtweite
CameraFogMode playerCam, 1
CameraFogRange playerCam, 15, 25
CameraFogColor playerCam, 0, 0, 0
CameraRange playerCam, 1, 30

;Fading
EntityColor fadeSprite, 255, 255, 255
EntityAlpha fadeSprite, 1
fadeAlpha = 1

;Hauptschleife
Repeat
	If playerTimer < MilliSecs() Then
		Gosub movePlayer
		Gosub updatePathState
		
		fadeAlpha = fadeAlpha - 0.1
		If fadeAlpha < 0 Then fadeAlpha = 0
		EntityAlpha fadeSprite, fadeAlpha
		
		;Am Ziel
		If Floor((EntityX(playerPiv1)+6)/18) = endX Then
			If Floor((EntityZ(playerPiv1)+6)/18) = endY Then
				Exit
			EndIf
		EndIf
		
		playerTimer = MilliSecs()+20
	EndIf
	
	Gosub updatePathFire
	Gosub updateBreath
	
	;Restart
	If EntityY(playerPiv1) <= 0 Then
		;Positionieren
		Gosub setPlayerStandard
		PositionEntity playerPiv1, (startX*18)+3, 4.01, (startY*18)+3
		If maze(startX, startY-1) = 2 Then RotateEntity playerPiv1, 0, 180, 0
		If maze(startX-1, startY) = 2 Then RotateEntity playerPiv1, 0, +90, 0
		If maze(startX, startY+1) = 2 Then RotateEntity playerPiv1, 0, 0, 0
		If maze(startX+1, startY) = 2 Then RotateEntity playerPiv1, 0, -90, 0
		Gosub setPlayerCollision
		
		;Labyrinth-Kollision
		EntityType mazeMesh, 2
		Collisions 1, 2, 2, 2
		
		;Sichtweite
		CameraFogMode playerCam, 1
		CameraFogRange playerCam, 15, 25
		CameraFogColor playerCam, 0, 0, 0
		CameraRange playerCam, 1, 30
		
		;Fading
		EntityColor fadeSprite, 255, 255, 255
		EntityAlpha fadeSprite, 1
		fadeAlpha = 1
	EndIf
	
	UpdateWorld
	RenderWorld
			
	Flip
	
	If KeyHit(1) Then End
Forever

FreeEntity mazeMesh
FreeEntity roomSprite
FreeEntity houseSprite
FreeTexture roomTex
FreeTexture houseTex
StopChannel fireLoop
StopChannel breathChannel

;-----------------------------------------------------------------------------------------------------------------------------------------------
;--------------------------------------------------------------- Das Ende ----------------------------------------------------------------------
;-----------------------------------------------------------------------------------------------------------------------------------------------

;Alles ntige laden
Include "buildOutside.bb"

;Licht
AmbientLight 0, 64, 128

;Protagonistin positionieren
Gosub setPlayerStandard
PositionEntity playerPiv1, 0, 4.01, -18
RotateEntity playerPiv1, 0, 0, 0
Gosub setPlayerCollision

;Welt-Kollision
EntityType outsideMesh, 2
Collisions 1, 2, 2, 2

;Fading
EntityColor fadeSprite, 255, 255, 255
EntityAlpha fadeSprite, 1
fadeAlpha = 1

;Hauptschleife
Repeat
	If playerTimer < MilliSecs() Then
		Gosub movePlayer
		
		;Rahmen
		If EntityY(playerPiv1) < 4 Then PositionEntity playerPiv1, EntityX(playerPiv1), 4, EntityZ(playerPiv1)
		If EntityX(playerPiv1) < -5 Then PositionEntity playerPiv1, -5, EntityY(playerPiv1), EntityZ(playerPiv1)
		If EntityX(playerPiv1) > 5 Then PositionEntity playerPiv1, 5, EntityY(playerPiv1), EntityZ(playerPiv1)
		
		fadeAlpha = fadeAlpha - 0.1
		If fadeAlpha < 0 Then fadeAlpha = 0
		EntityAlpha fadeSprite, fadeAlpha
		
		burningFrame = burningFrame + 0.13
		If burningFrame > 3 Then burningFrame = burningFrame - 2
		SetAnimTime burningMesh, burningFrame
		
		playerTimer = MilliSecs()+20
	EndIf
	
	If fireTimer < MilliSecs() Then
		fireFrame = 1-fireFrame
		EntityTexture fireSprite, fireTex, fireFrame
		fireTimer = MilliSecs()+130
	EndIf
	
	fadeAlpha = fadeAlpha - 0.02
	If fadeAlpha < 0 Then fadeAlpha = 0
	EntityAlpha fadeSprite, fadeAlpha
	
	UpdateWorld
	RenderWorld
			
	Flip
Until KeyHit(1)

;Lschen
FreeEntity outsideMesh
FreeTexture outsideTex
FreeEntity windowSprite
FreeTexture windowTey
FreeEntity burningMesh
FreeEntity fireSprite
FreeTexture fireTex

End



;Unterprogramme frs Spiel
Include "gameSub.bb"



;Map zeichnen
Function drawMap(px, py)
	For x = 0 To 29
		For y = 0 To 29
			Select maze(x, y)
				Case 0
					Color 0, 0, 0
					Plot x, y
				Case 1
					Color 128, 128, 128
					Plot x, y
				Case 2
					Color 255, 255, 255
					Plot x, y
			End Select
		Next
	Next
	Color 255, 0, 0
	Plot px, py
	Plot endX, endY
	Color 255, 255, 255
End Function